package com.gct.tools.etlcamelhuge.routeconfig;

import com.gct.common.util.SGTUtil;
import com.gct.tools.etlcamelhuge.MQ.MessageBody;
import com.gct.tools.etlcamelhuge.MQ.MessageProducer;
import com.gct.tools.etlcamelhuge.entity.DiagnoseMsg;
import org.apache.camel.*;
import org.apache.camel.builder.RouteBuilder;
//import org.apache.rocketmq.common.message.Message;
import org.apache.rocketmq.spring.core.RocketMQTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;

/**
 * class name: CamelJDBCConfiguration
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/4/14 下午3:16
 */
@Configuration
public class CamelJDBCConfiguration /*extends RouteBuilder */ {

    public Double min(String[] strings){
        double[] doubles = new double[strings.length];
        for (int i = 0; i < strings.length; i++) {
            doubles[i] = Double.parseDouble(strings[i]);
        }
        return Arrays.stream(doubles).min().getAsDouble();
    }
    //获取最大载荷
    public Double max(String[] strings){
        double[] doubles = new double[strings.length];
        for (int i = 0; i < strings.length; i++) {
            doubles[i] = Double.parseDouble(strings[i]);
        }
        return Arrays.stream(doubles).max().getAsDouble();
    }

    public String getDate(){
        return  LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
    }

    @Resource(name = "diagnoseMessageProducer")
    private MessageProducer producer;
    @Bean
    public RouteBuilder routeBuilderWithOracle1() {
        return new RouteBuilder() {
            private SortedSet<String> organization;
            private Map<String, Integer> orgIDs;
            private Integer orgID;

            //全部执行完成的大概时间在30-40分钟
            @Override
            public void configure() throws Exception {
                //24小时执行一次
                //单个执行时间30s左右,在之前有数据的情况下

//                //修改org_id
//                from("timer:mytimer1?period=604800000")
//                        .routeId("oracle-1")
//                        .setHeader("date", constant(getDate()))
//                        .setBody(simple("select org_id,org_id_pre from centralbase.cb_pc_organization where org_level = '3' "))
//                        .to("jdbc:centralbase")
//                        .split(body())
//                        .doTry()
//                        .setBody(simple("update centralbase.cb_cd_well_source set org_id = '${body[org_id]}' where station_id = '${body[org_id_pre]}'"))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:oracle-1->  centralbase.cb_pc_organization update date faild")
//                        .end();

//                        //level3   ------>  用来导入层级
//                        .setBody(simple("select distinct a.org_name_cj zyq,  a.project_name qk , a.station_name zd  from V_CD_WELL_SOURCE_YC a "))
//                        .to("jdbc:oracle")
//                        .split(body()).process(exchange -> {
//                            Message in = exchange.getIn();
//                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
//                            String org_level2 = aRow.get("ZYQ") + "@" + aRow.get("QK")+ "@" + aRow.get("ZD");
//                            String org_level3 = aRow.get("ZYQ") + "@" + aRow.get("QK");
//                            String orgname = aRow.get("ZD").toString();
//                            String zyq = aRow.get("ZYQ").toString();
//                            aRow.put("station_id", org_level2);
//                            aRow.put("org_name",orgname);
//                            aRow.put("zyq",zyq);
//                            aRow.put("lev3",org_level3);
//                        })
//
//                        .log("${body[ZYQ]}")
//                        .doTry()
//                        .setBody(simple("insert into centralbase.cb_pc_organization(org_name,org_level,parent_id,org_id_pre)" +
//                                "values('${body[org_name]}','3',(select org_id from centralbase.cb_pc_organization where org_id_pre = '${body[lev3]}'),'${body[station_id]}') "))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:oracle-1->  centralbase.cb_pc_organization insert date faild")
//                        .end();

//                            level2
//                        .setBody(simple("select org_id_pre from centralbase.cb_pc_organization where org_id_pre like '%@%'"))
//                        .to("jdbc:centralbase")
////                        .doCatch(Exception.class)
//                        .split(body())
//                        .log("${body[org_id_pre]}")
//                        .doTry()
//                        .setBody(simple("update centralbase.cb_pc_organization set parent_id = (select org_id from centralbase.cb_pc_organization where org_id_pre = (select split_part(org_id_pre, '@', 1) from centralbase.cb_pc_organization  where org_id_pre = '${body[org_id_pre]}') ) where org_id_pre = '${body[org_id_pre]}' "))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:oracle-2->  centralbase.cb_pc_organization insert date faild")
//                        .end();
                            //  ,  a.project_name qk , a.station_name zd
//                        .setBody(simple("select distinct a.org_name_cj zyq ,  a.project_name qk from V_CD_WELL_SOURCE_YC a "))
//                        .to("jdbc:oracle")
//                        .split(body()).process(exchange -> {
//                            Message in = exchange.getIn();
//                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
//                            String org_level2 = aRow.get("ZYQ") + "@" + aRow.get("QK");
//                            String org_level3 = aRow.get("ZYQ").toString() ;
//                            String orgname = aRow.get("QK").toString();
//                            String zyq = aRow.get("ZYQ").toString();
//                            aRow.put("station_id", org_level2);
//                            aRow.put("org_name",orgname);
//                            aRow.put("zyq",zyq);
//                            aRow.put("lev3",org_level3);
//                        })
//                        .log("${body[ZYQ]}")
//                        .doTry()
//                        .setBody(simple("insert into centralbase.cb_pc_organization(org_name,org_level,parent_id,org_id_pre)" +
//                                "values('${body[org_name]}','2','0','${body[station_id]}') "))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:oracle-1->  centralbase.cb_pc_organization insert date faild")
//                        .end();

//                        .transform()
//                        .body((result) -> {
//                            organization = new TreeSet<>();
//                            orgID = 0;
//                            orgIDs = new HashMap<>();
//                            return result;
//                        })
//                        .step("1")
//                        .split(body()).process(exchange -> {
//                    Message in = exchange.getIn();
//                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
//                    String org_level3 = aRow.get("ZYQ") + "@" + aRow.get("QK") + "@" + aRow.get("ZD");
//                    String org_level2 = aRow.get("ZYQ") + "@" + aRow.get("QK");
//                    String org_level1 = aRow.get("ZYQ").toString();
//                    aRow.put("station_id", org_level3);
//                    //这里是重新生成的orgid，最好先查一下centralbase里已有的
//                    //默认一张新表
//                    if (organization.add(org_level1)) {
//                        orgID++;
//                        orgIDs.put(org_level1, orgID);
//                    }
//                    if (organization.add(org_level2)) {
//                        orgID++;
//                        orgIDs.put(org_level2, orgID);
//                    }
//                    if (organization.add(org_level3)) {
//                        orgID++;
//                        orgIDs.put(org_level3, orgID);
//                    }
//                })
//                    .transform().body((re) -> {
//                    List<Map<String, Object>> rows = new ArrayList<>();
//                    int code = 0;
//                    for (String s : organization) {
//                        code++;// code is same as org_id
//                        String[] orgs = s.split("@");
//                        Map<String, Object> row = new HashMap<>();
//                        row.put("org_id_pre", s);
//                        row.put("org_code", code);
//                        row.put("org_id", "" + code);
//                        switch (orgs.length) {
//                            case 1:
//                                row.put("org_name", orgs[0]);
//                                row.put("org_level", 1);
//                                row.put("org_parent", "0");
//                                break;
//                            case 2:
//                                row.put("org_name", orgs[1]);
//                                row.put("org_level", 2);
//                                row.put("org_parent", orgIDs.get(orgs[0]).toString());
//                                break;
//                            case 3:
//                                row.put("org_name", orgs[2]);
//                                row.put("org_level", 3);
//                                row.put("org_parent", orgIDs.get(orgs[0] + "@" + orgs[1]).toString());
//                                break;
//                        }
//                        rows.add(row);
//                    }
//                    return rows;
//                }).split(body())
//                        .doTry()
//                        .setBody(simple("insert into centralbase.cb_pc_organization(org_id,org_code,org_name,org_level,parent_id,org_id_pre)" +
//                                "values('${body[org_id]}','${body[org_code]}','${body[org_name]}','${body[org_level]}','${body[org_parent]}','${body[org_id_pre]}') "))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:oracle-1->  centralbase.cb_pc_organization insert date faild")
//                        .end()


                //导入井的基本信息 导一次就够了
//                from("timer:mytimer1?period=604800000")
//                        .routeId("oracle-1")
//                        .setHeader("date", constant(getDate()))
//                        .setBody(simple("select distinct a.well_common_name jh, a.org_name_cj zyq, a.GROUP_UNIT_NAME cw, a.station_name zd, a.project_name qk from V_CD_WELL_SOURCE_YC a "))
//                        .to("jdbc:oracle")
//                        .transform()
//                        .body((result) -> {
//                            organization = new TreeSet<>();
//                            orgID = 0;
//                            orgIDs = new HashMap<>();
//                            return result;
//                        })
//                        .step("1")
//                        .split(body()).process(exchange -> {
//                    Message in = exchange.getIn();
//                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
//                    String org_level3 = aRow.get("ZYQ") + "@" + aRow.get("QK") + "@" + aRow.get("ZD");
//                    String org_level2 = aRow.get("ZYQ") + "@" + aRow.get("QK");
//                    String org_level1 = aRow.get("ZYQ").toString();
//                    aRow.put("station_id", org_level3);






//                查询井对应dym不为空的数据 --目前是只要对应井能查到dym不为空的,无论是什么时间的,都放进去
//                将查询到的DYM数据更新到cb_pc_pro_wellbore_status_daily中
//                0 0 */1 * * ? 每1个小时执行一次
//                单独执行时间是4m15s 317条数据


//                 没用from("timer:mytimer5?period=3600000")
//                        .routeId("oracle-5")
//                        .setHeader("date", constant(getDate() + " 00:00:00"))
//                        //三个月之内dym不为空的数据
//                        //.setBody(simple("SELECT distinct jh,rq,dym FROM DBA01 WHERE  rq between to_date(TO_CHAR(ADD_MONTHS(SYSDATE,-3),'yyyy-MM-dd'),'yyyy-MM-dd')and to_date(TO_CHAR(SYSDATE,'yyyy-MM-dd'),'yyyy-MM-dd') and dym is not null;"))
//                        .setBody(simple("SELECT  distinct jh,max(rq),dym FROM DBA01 WHERE dym is not null group by jh,dym"))
//                        .to("jdbc:oracle")
//                        .split(body())
//                        .doTry()
//                        .setBody(simple("update centralbase.cb_pc_pro_wellbore_status_daily set start_pump_liq_level = '${body[DYM]}' where well_id = '${body[JH]}' and prod_date::date  = '${header.date}' "))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:oracle-5->  centralbase.cb_pc_pro_wellbore_status_daily update date faild")
//                        .end();






//
//                from("timer:mytimer6?period=3600000")
//                        .routeId("oracle-6")
//                        .setHeader("date", constant(getDate() + " 00:00:00"))
//                        //五个月之内bj不为空的数据
//                        .setBody(simple("SELECT distinct jh,bj FROM DBA01 WHERE  rq between to_date(TO_CHAR(ADD_MONTHS(SYSDATE,-5),'yyyy-MM-dd'),'yyyy-MM-dd')and to_date(TO_CHAR(SYSDATE,'yyyy-MM-dd'),'yyyy-MM-dd') and bj is not null"))
//                        .to("jdbc:oracle")
//                        .split(body())
//                        .doTry()
//                        .setBody(simple("update centralbase.cb_temp_well_mech_runtime set pump_diameter = '${body[BJ]}' where well_id = '${body[JH]}' "))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:oracle-6->  centralbase.cb_temp_well_mech_runtime update date faild")
//                        .end();
//                //从天安哪里获取的数据
//                //0 0 */1 * * ? 每1个小时执行一次
//                //单独执行一小时的数据30s
//                from("timer:mytimer8?period=3600000")
//                        .routeId("jdbc-gtsj-?")
//                        .setBody(simple("select max(prod_date) from centralbase.cb_temp_well_mech_runtime "))
//                        .to("jdbc:centralbase")
//                        .split(body())
//                        .setHeader("date", simple("${body[max]}"))
//                        .setBody(simple("select distinct well_name,dyna_create_time,check_date,displacement,disp_load,stroke,frequency,susp_max_load,susp_min_load from public.pc_fd_pumpjack_dyna_dia_t where   dyna_create_time > '${header.date}' "))
//                        .to("jdbc:gtsj")
//                        .split(body()).process(exchange -> {
//                    Message in = exchange.getIn();
//                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
//                    String prod_date = aRow.get("dyna_create_time").toString().split("\\+")[0];
//                    aRow.put("dyna_create_time", prod_date);
//                    if (aRow.get("displacement") != null && !aRow.get("displacement").equals("") && aRow.get("disp_load") != null && !aRow.get("disp_load").equals("")) {
//                        String[] displacements = aRow.get("displacement").toString().split(";");//10 四舍五入
//                        //String[] displacements = wy(displacementsOld);
//                        String[] disp_loads = aRow.get("disp_load").toString().split(";");
//                        Double susp_max_load = max(disp_loads);
//                        Double susp_min_load = min(disp_loads);
//                        String sgt = "";
//                        for (int i = 0; i < displacements.length; i++) {
//                            sgt = sgt + displacements[i] + "," + disp_loads[i] + ",";
//                        }
//                        String[] s = sgt.split(",");
//                        String w = "";
//                        for (int i = 0; i < s.length; i++) {
//                            w += new BigDecimal(Math.round(Double.parseDouble(s[i]) * 100)).stripTrailingZeros().toPlainString() + ",";
//                        }
//                        Double[][] doubles = SGTUtil.encodeToDoubleArray(w);
//                      /*  for (int i = 0;i<doubles.length;i++){
//                            doubles[i][0] = doubles[i][0] / 10;
//                        }*/
//                        aRow.put("sgt", SGTUtil.encodeToString(doubles));
//                        aRow.put("susp_max_load",susp_max_load);
//                        aRow.put("susp_min_load",susp_min_load);
//                    }
//                    if (aRow.get("stroke") == null) aRow.put("stroke", "0.0");
//                    if (aRow.get("frequency") == null) aRow.put("frequency", "0.0");
//                    if (aRow.get("susp_max_load") == null) aRow.put("susp_max_load", "0.0");
//                    if (aRow.get("susp_min_load") == null) aRow.put("susp_min_load", "0.0");
//                    if (aRow.get("frequency") != null){
//                        BigDecimal bd=new BigDecimal(aRow.get("frequency").toString());
//                        double frequency=bd.setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue();
//                        aRow.put("frequency",frequency);
//                    }
//                    if (aRow.get("stroke") != null){
//                        double stroke1 = Double.parseDouble(aRow.get("stroke").toString());
//                        BigDecimal bd=new BigDecimal(stroke1);
//                        double stroke=bd.setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue();
//                        aRow.put("stroke",stroke);
//                    }
//                })
//                        .doTry()
//                        .setBody(simple("insert into centralbase.cb_temp_well_mech_runtime(well_id,prod_date,stroke_length,stroke_frequency,susp_max_load,susp_min_load,sgt) " +
//                                "select '${body[well_name]}','${body[dyna_create_time]}','${body[stroke]}','${body[frequency]}','${body[susp_max_load]}','${body[susp_min_load]}','${body[sgt]}' " +
//                                "where NOT EXISTS (SELECT * FROM centralbase.cb_temp_well_mech_runtime WHERE well_id = '${body[well_name]}' and  prod_date = '${body[dyna_create_time]}' )"))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:jdbc-gtsj-?->  centralbase.cb_temp_well_mech_runtime insert date faild")
//                        .end();

                /*——————————————————————————————————————————————————————————-*/

                //单独执行时间10s    A2数据
                from("timer:mytimer2?period=3600000")
                        .routeId("oracle-2")
                        .setHeader("date", constant(getDate()))
                        .setBody(simple("SELECT DISTINCT well_id wellid FROM centralbase.cb_temp_well_mech_runtime where prod_date > '${header.date}' "))
                        .to("jdbc:centralbase")
                        .split(body())
//                        .split(body())
//                       .setBody(simple("select  distinct jh,rq,cyfs,yz,hysx , yysx ,tysx,bs,dym from DBA01 where rq  = to_date('${header.date}','yyyy-MM-dd') and qyrq is not null "))
//                        .setBody(simple("select v.WELL_COMMON_NAME jh,v.PROD_DATE rq,v.OIL_PRODUCTION_METHOD cyfs,v.PUMP_DIAMETER yz,v.BACK_PRES hysx,v.MAX_TUBING_PRES yysx,v.MAX_CASING_PRES tysx,v.PUMP_DEPTH bs , l.DYNAMIC_LIQ_LEVEL dym from V_PC_PRO_COM_DAILY_CYYC v " +
//                                " left join ( select * from V_TEMP_WELL_MECH_ALL where PROD_DATE = to_date('${header.date}','yyyy-MM-dd') ) l on l.well_id = v.well_id  where v.PROD_DATE = to_date('${header.date}','yyyy-MM-dd') "))
                        .setBody(simple("select v.WELL_COMMON_NAME jh,v.PROD_DATE rq,v.OIL_PRODUCTION_METHOD cyfs,v.PUMP_DIAMETER yz,v.BACK_PRES hysx,v.MAX_TUBING_PRES yysx,v.MAX_CASING_PRES tysx,v.PUMP_DEPTH bs from V_PC_PRO_COM_DAILY_CYYC v  where  v.PROD_DATE = to_date('${header.date}','yyyy-MM-dd')  and  v.WELL_COMMON_NAME = '${body[wellid]}' "))

                        .to("jdbc:oracle")
                        .split(body()).process(exchange -> {
                    Message in = exchange.getIn();
                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
                    if (aRow.get("YZ") == null) aRow.put("YZ", "0.0");
                    if (aRow.get("HYSX") == null) aRow.put("HYSX", "0.0");
                    if (aRow.get("YYSX") == null) aRow.put("YYSX", "0.0");
                    if (aRow.get("TYSX") == null) aRow.put("TYSX", "0.0");
                    if (aRow.get("BS") == null) aRow.put("BS", "0.0");
                    if (aRow.get("DYM") == null)aRow.put("DYM","0.0");
                })
                        .log("mytimer2")
                        .doTry()
                        .setBody(simple("insert into centralbase.cb_pc_pro_wellbore_status_daily(well_id,prod_date,oil_prod_method,oil_nozzle,back_pres,tubing_pres,casing_pres,pump_depth,start_pump_liq_level) " +
                                "select '${body[JH]}','${body[RQ]}','${body[CYFS]}','${body[YZ]}','${body[HYSX]}','${body[YYSX]}','${body[TYSX]}','${body[BS]}' ,'${body[DYM]}'" +
                                "where NOT EXISTS ( SELECT * FROM centralbase.cb_pc_pro_wellbore_status_daily WHERE well_id = '${body[JH]}' and  prod_date = '${body[RQ]}')"))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:oracle-2->  centralbase.cb_pc_pro_wellbore_status_daily insert date faild")
                        .end();

                //单独执行时间30s
                from("timer:mytimer3?period=3600000")
                        .routeId("oracle-3")
                        .setHeader("date", constant(getDate()))
                        .setBody(simple("SELECT DISTINCT well_id wellid FROM centralbase.cb_temp_well_mech_runtime where prod_date > '${header.date}' "))
                        .doTry()
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("centralbase error")
                        .split(body())
//                        .setBody(simple("select distinct  jh,rq,scsj, rcyl1,rcyl,rcql,hs, bz from DBA01 where rq  = to_date('${header.date}','yyyy-MM-dd') and qyrq is not null "))
                        .setBody(simple("select  WELL_COMMON_NAME jh, PROD_DATE rq,PROD_TIME scsj, LIQ_PROD_DAILY rcyl1,OIL_PROD_DAILY rcyl,GAS_PROD_DAILY rcql,WATER_CUT hs,REMARKS bz from V_PC_PRO_COM_DAILY_CYYC where prod_date = to_date('${header.date}','yyyy-MM-dd') and WELL_COMMON_NAME = '${body[wellid]}'"))
                        .doTry()
                        .to("jdbc:oracle")
                        .doCatch(Exception.class)
                        .log("oracle error")
                        .split(body()).process(exchange -> {
                    Message in = exchange.getIn();
                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
                    if (aRow.get("SCSJ") == null) aRow.put("SCSJ", "0.0");
                    if (aRow.get("RCYL1") == null) aRow.put("RCYL1", "0.0");
                    if (aRow.get("RCYL") == null) aRow.put("RCYL", "0.0");
                    if (aRow.get("RCQL") == null) aRow.put("RCQL", "0.0");
                    if (aRow.get("HS") == null) aRow.put("HS", "0.0");
                    if (aRow.get("BZ") == null) aRow.put("BZ", "");
                    aRow.put("RCSL",-1);
                    aRow.put("QYB",-1);
                    aRow.put("SQB",-1);
                    if (aRow.get("RCQL")!=null && aRow.get("RCYL")!=null && !aRow.get("RCYL").equals("0.0") && aRow.get("RCYL") != "0.0"){
                        double qyb = Double.valueOf(aRow.get("RCQL").toString()) / Double.valueOf(aRow.get("RCYL").toString());
                        if (!Double.isNaN(qyb) && !Double.isInfinite(qyb)){
                            BigDecimal bd=new BigDecimal(qyb);
                            double d1=bd.setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue();
                            aRow.put("QYB",d1);
                        }
                    }
                    if (aRow.get("RCYL1")!=null && aRow.get("HS") != null && !aRow.get("HS").equals("0.0") && aRow.get("HS") != "0.0"){
                        double rcsl = (Double.valueOf(aRow.get("RCYL1").toString()) * Double.valueOf(aRow.get("HS").toString()))/100;
                        if (!Double.isNaN(rcsl) && !Double.isInfinite(rcsl)) {
                            BigDecimal bd = new BigDecimal(rcsl);
                            double d1 = bd.setScale(1, BigDecimal.ROUND_HALF_UP).doubleValue();
                            aRow.put("RCSL", d1);
                        }
                    }
                    if (aRow.get("RCQL") != null && aRow.get("RCSL") != null && !aRow.get("RCQL").equals("0.0") && aRow.get("RCQL") != "0.0" ){
                        double sqb = Double.valueOf(aRow.get("RCSL").toString()) / Double.valueOf(aRow.get("RCQL").toString());
                        if (!Double.isNaN(sqb) && !Double.isInfinite(sqb)) {
                            BigDecimal bd = new BigDecimal(sqb);
                            double d1 = bd.setScale(1, BigDecimal.ROUND_HALF_UP).doubleValue();
                            aRow.put("SQB", d1);
                        }
                    }
                    if (!aRow.containsKey("SMD")){
                        aRow.put("SMD",1);
                    }
                    if (!aRow.containsKey("YMD")){
                        aRow.put("YMD",0.85);
                    }
                })
                        .log("mytimer3")
                        .doTry()
                        .setBody(simple("insert into centralbase.cb_pc_pro_wellbore_vol_daily(well_id,prod_date,prod_time,liq_prod_daily,oil_prod_daily,gas_prod_daily,water_cut,remarks,gas_oil_ratio,water_prod_daily,water_gas_ratio,surface_crude_water_density,surface_crude_oil_density) " +
                                "select '${body[JH]}','${body[RQ]}','${body[SCSJ]}','${body[RCYL1]}','${body[RCYL]}','${body[RCQL]}','${body[HS]}','${body[BZ]}','${body[QYB]}','${body[RCSL]}','${body[SQB]}','${body[SMD]}','${body[YMD]}' " +
                                "where NOT EXISTS ( SELECT * FROM centralbase.cb_pc_pro_wellbore_vol_daily WHERE well_id = '${body[JH]}' and  prod_date = '${body[RQ]}' )"))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:oracle-3->  centralbase.cb_pc_pro_wellbore_status_daily insert date faild")
                        .doTry()
                        .setBody(simple("update centralbase.cb_pc_pro_wellbore_vol_daily set  water_prod_daily =null where water_prod_daily = -1 and prod_date = '${header.date}' "))
                        .to("jdbc:centralbase")
                        .setBody(simple("update centralbase.cb_pc_pro_wellbore_vol_daily set  gas_oil_ratio =null where gas_oil_ratio = -1 and prod_date = '${header.date}' "))
                        .to("jdbc:centralbase")
                        .setBody(simple("update centralbase.cb_pc_pro_wellbore_vol_daily set  water_gas_ratio =null where water_gas_ratio = -1 and prod_date = '${header.date}' "))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:oracle-3->  centralbase.cb_pc_pro_wellbore_vol_daily update date faild")
                        .end();

//                //0 0 */1 * * ? 每1个小时执行一次
//                //单独执行一次30s
                from("timer:mytimer4?period=3600000")
                    .routeId("oracle-4")
                    .setHeader("date", constant(getDate()))
//                        .setBody(simple("select distinct jh,rq,dym,jy,ly,bj,bs,bx,zs,cc,cs,blx,dl from DBA01 where rq  = to_date('${header.date}','yyyy-MM-dd') and qyrq is not null  "))
//                        .setBody(simple("select distinct b.well_common_name jh,  a.prod_date rq,a.static_pressure jy,a.flow_pres ly,a.pump_diameter bj,a.pump_depth bs,a.pump_efficiency bx,a.rotate_frequency zs,a.stroke_length cc,a.stroke_frequency cs,a.pump_type blx,a.elec_frequency dl from (select * from V_TEMP_WELL_MECH_ALL a1 where a1.prod_date = to_date('${header.date}', 'yyyy-MM-dd')) a left join  V_CD_WELL_SOURCE_YC    b on a.well_id = b.well_id "))
                    .setBody(simple("SELECT DISTINCT well_id jh FROM centralbase.cb_temp_well_mech_runtime where prod_date > '${header.date}' "))
                    .to("jdbc:centralbase")
                    .split(body()).process(exchange -> {
                        Message in = exchange.getIn();
                        HashMap<String, Object> aRow = in.getBody(HashMap.class);
                        aRow.put("JH", aRow.get("jh").toString());
                        in.setHeader("JH",aRow.get("jh").toString());
                })
                    .setBody(simple("   select well_id wellid from  V_CD_WELL_SOURCE_YC  where well_common_name = '${body[JH]}' "))
                    .to("jdbc:oracle")
                    .split(body()).process(exchange -> {
                        Message in = exchange.getIn();
                        HashMap<String, Object> aRow = in.getBody(HashMap.class);
                        aRow.put("wellid", aRow.get("WELLID").toString());
                })
                    .setBody(simple("  select * from( Select t.prod_date rq,t.static_pressure jy,t.flow_pres ly,t.pump_diameter bj,\n" +
                            "                                      t.pump_depth bs,t.pump_efficiency bx,t.rotate_frequency zs,t.stroke_length cc,t.stroke_frequency cs,\n" +
                            "                                      t.pump_type blx,t.elec_frequency dl, row_number() Over(Partition By t.well_id\n" +
                            "                                Order By t.prod_date desc ) rn   FROM V_TEMP_WELL_MECH_ALL  t where well_id = '${body[wellid]}' and dynamic_liq_level > 0)where rn = 1 "))
                    .to("jdbc:oracle")
                    .split(body()).process(exchange -> {
                        Message in = exchange.getIn();
                        HashMap<String, Object> aRow = in.getBody(HashMap.class);
                        if (aRow.get("JY") == null) aRow.put("JY", "0.0");
                        if (aRow.get("LY") == null) aRow.put("LY", "0.0");
                        if (aRow.get("BJ") == null) aRow.put("BJ", "0.0");
                        if (aRow.get("BS") == null) aRow.put("BS", "0.0");
                        if (aRow.get("BX") == null) aRow.put("BX", "0.0");
                        if (aRow.get("ZS") == null) aRow.put("ZS", "0.0");
                        if (aRow.get("CC") == null) aRow.put("CC", "0.0");
                        if (aRow.get("CS") == null) aRow.put("CS", "0.0");
                        if (aRow.get("BLX") == null) aRow.put("BLX", "");
                        if (aRow.get("DL") == null) aRow.put("DL", "0.0");
                })
                        .log("mytimer4")
                        .doTry()
                        .setBody(simple("insert into centralbase.cb_temp_well_mech_daily(well_id,prod_date,static_pressure,flow_pres,pump_diameter,pump_depth,pump_efficiency,rotate_frequency,stroke_length,stroke_frequency,pump_type,elec_frequency) " +
                                "select '${header.JH}','${body[RQ]}','${body[JY]}','${body[LY]}','${body[BJ]}','${body[BS]}','${body[BX]}','${body[ZS]}','${body[CC]}','${body[CS]}','${body[BLX]}','${body[DL]}' " +
                                "where NOT EXISTS ( SELECT * FROM centralbase.cb_temp_well_mech_daily WHERE well_id = '${body[JH]}' and  prod_date = '${body[RQ]}' )"))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:oracle-4->  centralbase.cb_temp_well_mech_daily insert date faild")
                        .end();


                from("timer:mytimer7?period=3600000")
                        .routeId("oracle-7")
                        .setHeader("date", constant(getDate() + " 00:00:00"))
                        //三个月之内dym不为空的数据
                        //.setBody(simple("SELECT distinct jh,rq,dym FROM DBA01 WHERE  rq between to_date(TO_CHAR(ADD_MONTHS(SYSDATE,-3),'yyyy-MM-dd'),'yyyy-MM-dd')and to_date(TO_CHAR(SYSDATE,'yyyy-MM-dd'),'yyyy-MM-dd') and dym is not null;"))
                        .setBody(simple("select well_id,prod_date,start_pump_liq_level,pump_depth from centralbase.cb_pc_pro_wellbore_status_daily where prod_date = '${header.date}' "))
                        .to("jdbc:centralbase")
                        .split(body()).process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            aRow.put("submergence_depth",null);
                    if (aRow.get("start_pump_liq_level")!=null && aRow.get("pump_depth")!=null){
                        double cmd= Double.valueOf(aRow.get("pump_depth").toString())-Double.valueOf(aRow.get("start_pump_liq_level").toString())/10;
                        BigDecimal bd=new BigDecimal(cmd);
                        double cmd1=bd.setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue();
                        aRow.put("submergence_depth",cmd1);
                    }
                })
                        .doTry()
                        .setBody(simple("update centralbase.cb_pc_pro_wellbore_status_daily set submergence_depth = '${body[submergence_depth]}' where well_id = '${body[well_id]}' and prod_date  = '${body[prod_date]}'"))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:oracle-7->  centralbase.cb_pc_pro_wellbore_status_daily update date faild")
                        .end();




//                from("timer:mytimer9?period=3600000")
//                        .routeId("centralbase-2")
//                        .setHeader("date", constant(getDate() + " 00:00:00"))
//                        .setBody(simple("select distinct rn.well_id,cb.prod_date,rn.pump_diameter  from centralbase.cb_temp_well_mech_runtime rn ,centralbase.cb_pc_pro_wellbore_status_daily cb where cb.well_id = rn.well_id " +
//                                "and cb.prod_date = '${header.date}' "))
//                        .to("jdbc:centralbase")//.log("${body}")
//                        .split(body()).process(exchange -> {
//                    Message in = exchange.getIn();
//                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
//                    aRow.putIfAbsent("pump_diameter", "0.0");
//                })
//                        .doTry()
//                        .setBody(simple("update centralbase.cb_pc_pro_wellbore_status_daily set oil_nozzle = '${body[pump_diameter]}' where well_id ='${body[well_id]}' and prod_date='${body[prod_date]}' "))
//                        .to("jdbc:centralbase")
//                        .doCatch(Exception.class)
//                        .log("${header.date}"+" routeId:centralbase-2->  centralbase.cb_pc_pro_wellbore_status_daily update date faild")
//                        .end();
//
                from("timer:mytimer10?period=3600000")
                        .routeId("centralbase-3")
                        .setHeader("date", constant(getDate()))
                        .setBody(simple("select well_id,avg(stroke_length) stroke_length  ,avg(stroke_frequency) stroke_frequency from centralbase.cb_temp_well_mech_runtime where prod_date::date='${header.date}' group by well_id"))
                        .to("jdbc:centralbase")//.log("${body}")
                        .split(body()).process(exchange -> {
                        Message in = exchange.getIn();
                        HashMap<String, Object> aRow = in.getBody(HashMap.class);
                        if (aRow.get("stroke_length")!=null && aRow.get("stroke_frequency")!=null){
                        double stroke_length=Double.parseDouble(aRow.get("stroke_length").toString());
                        double stroke_frequency=Double.parseDouble(aRow.get("stroke_frequency").toString());
                        BigDecimal bd=new BigDecimal(stroke_length);
                        double stroke_lengt1=bd.setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue();
                        BigDecimal bd1=new BigDecimal(stroke_frequency);
                        double stroke_frequency1=bd1.setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue();
                        aRow.put("strokeLength",stroke_lengt1);
                        aRow.put("strokeFrequency",stroke_frequency1);
                    }
                })
                        .doTry()
                        .setBody(simple("update centralbase.cb_temp_well_mech_daily set stroke_length='${body[strokeLength]}' ,stroke_frequency ='${body[strokeFrequency]}' where well_id = '${body[well_id]}' and prod_date::date='${header.date}' "))
                        .to("jdbc:centralbase")
                        .doCatch(Exception.class)
                        .log("${header.date}"+" routeId:centralbase-3->  centralbase.cb_temp_well_mech_daily update date faild")
                        .end();

                from("timer:mytimer11?period=3600000")
                        .routeId("centralbase-1")
                        .setBody(simple("select so.well_id,so.well_common_name,so.org_id,ti.prod_date,ti.stroke_frequency,ti.stroke_length,ti.sgt from centralbase.cb_temp_well_mech_runtime ti, centralbase.cb_cd_well_source so where ti.well_id = so.well_id and ti.prod_date =(select max(prod_date) from centralbase.cb_temp_well_mech_runtime) and ti.stroke_length > 0 "))
                        .to("jdbc:centralbase")
                        .split(body())
                        .doTry()
                        .process(exchange -> {
                            Message in = exchange.getIn();
                            HashMap<String, Object> aRow = in.getBody(HashMap.class);
                            String wellName =aRow.get("well_common_name").toString();
                            String wellId =aRow.get("well_id").toString();
                            String orgId = aRow.get("org_id").toString();
                            String prodDate = aRow.get("prod_date").toString().substring(0,19);
                            Double strokeLength = Double.valueOf(aRow.get("stroke_length").toString());
                            Double strokeFrequency = Double.valueOf(aRow.get("stroke_frequency").toString());
                            String sgt = aRow.get("sgt").toString();
                            DiagnoseMsg diagnoseMsg = new DiagnoseMsg(wellId, wellName, orgId, prodDate, sgt, LocalDateTime.now().toString(), strokeLength, strokeFrequency);
                            producer.send((MessageBody) diagnoseMsg);
                        })
                        .doCatch(Exception.class)
                        .log("${header.date}"+" rocketMQ send data faild")
                        .end();

            }
        };
    }
}